/*global addObject, runLoop, type, V, update */

var nouncover = false;
var won = false;


function rndexp() {
  sfx.bang();
  var x = Math.random() * 300;
  var y = Math.random() * 300;
  smoke([x, y]);
  removeBricksNear([x, y], 30);
}

function nrandexp(n, cb) {
  var t = 220;
  if (n == 0)
    setTimeout(cb, t);
  else setTimeout(function() {
    rndexp();
    nrandexp(n - 1, cb);
  }, t);
}

window.onload = function() {
  loadGraphics(function() {

    runLoop(update);

    if (window.location.hash == '#2') {
      setTimeout(function() {
        nrandexp(3, twoLevelScenario);
      }, 500);
    }
    else {
      bigBlocksScenario();
    }
    //bossScenario();
  });
};

function after(name, advice) {
  var fn = window[name];
  window[name] = function() {
    fn.apply(null, arguments);
    advice.apply(null, arguments);
  };
}


function bigBlocksScenario() {

  if (window.doneBbs)
    return;
  window.doneBbs = true;

  var size = [25, 25];
  var map = {};

  function at(loc) {
    var block = map[loc];
    return block && (!block.dead) && block;
  }

  function destroyBlockAt(loc) {
    var block = at(loc);
    if (block) {
      block.dead = true;
    }
  }

  after('explode', function(pos) {
    debug('explpos', pos);
    var loc = [
      Math.floor(pos[0] / 25),
      Math.floor(pos[1] / 25)
    ];
    debug('explloc', loc);
    destroyBlockAt(V.add(loc, [0, 0]));
    destroyBlockAt(V.add(loc, [0, 1]));
    destroyBlockAt(V.add(loc, [0, -1]));
    destroyBlockAt(V.add(loc, [-1, 0]));
    destroyBlockAt(V.add(loc, [1, 0]));
    destroyBlockAt(V.add(loc, [1, -1]));
    destroyBlockAt(V.add(loc, [-1, -1]));
  });

  var goodX = _.sample([2, 3, 4, 5, 6, 7, 8, 9]);
  debug('gx', goodX);

  function uncover(loc) {
    if (nouncover)
      return;
    var pos = V.add(V.mul(loc, size) , V.scale(size, .5));

    if (loc[1] == 1 && (loc[0] == goodX || Math.random() < (1/3))) {
      spawnNuke({pos: V.sub(pos, [8, 8])});
      return;
    }

    if (loc[1] < 2) {
      return;
    }

    // magic
    if (V.eq(loc, [2, 5]) || V.eq(loc, [9, 5])) {
      pos = V.add(pos, [-8,-8]);
      var src = spawnEnemySource({pos: pos, etype: 'magic'});
      src.target = false;
      return;
    }

    // normal
    _.sample([
      function() {
        pos = V.add(pos, [-8,-8]);
        spawnEnemySource({pos: pos});
      },
      function() {
        pos = V.add(pos, [-5,-5]);
        spawnEnemy({pos: pos});
      },
      function() {
        pos = V.add(pos, [-8,-8]);
        spawnEnemySource({pos: pos});
      },
    ])();
  }

  function spawnBlock(loc) {
    map[loc] = addObject({
      hp: 1,
      solid: true,
      target: true,
      graphic: 'stone',
      pos: V.mul(size, loc),
      onDie: function(block) {
        console.log(block.pos);
        smoke(block.pos);
        if (!nouncover)
          removeBricksNear(block.pos, 20);
        uncover(loc);
      },
      size: size
    });
  }

  function forLocs(cb) {
    for (var y=0; y<6; y++)
      for (var x=0; x<12; x++) {
        cb([x, y]);
      }
  }

  forLocs(function(loc) {
    if ((5 <= loc[0] && loc[0] <= 6) && (loc[1] > 3))
      ;
    else if (2 <= loc[1] && loc[1] <= 3 && 2 <= loc[0] && loc[0] <= 9)
      ;
    else if ((loc[0] == 0 || loc[0] == 11) && (2 < loc[1] && loc[1] < 5))
      ;
    else
      spawnBlock(loc);
  });

  spawnBigBlock({pos: [-1 * 25, 3 * 25]});
  spawnBigBlock({pos: [11 * 25, 3 * 25]});
  spawnBigBlock({pos: [5 * 25, 4 * 25]});
}


function upperStairsScenario() {

  var n = 3;
  var off = 30;

  var increment = (150 - off) / (n);
  var uppers = [];

  function drop(i, from) {
    var x = (i + .5) * increment + off;
    uppers[i] = dropUpper(x, from);
    uppers[i].onDie = function(upper) {
      if (!won)
        drop(i, upper.pos[1]);
    };
  }

  for (var i = 0; i < n; i++) {
    drop(i);
  }

  setInterval(function() {
    var dead = _.filter(uppers, 'dead');
    if (dead.length) {
      var u = _.sample(dead);
      uppers[uppers.indexOf(u)] = dropUpper(u.x);
    }

  }, 2000);
}

function dropCorkscrew(x, height) {
  console.log(x, height);

  var y = - height - 10;
  var width = 30;

  var platform = spawnMovingPlatform({
    pos: [x + 5 - width/2, y - 10],
    size: [width, 10],
    dir: _.sample([-1, 1]),
    enabled: false,
    vel: [0, 0],
    hitsBounds: true,
    fallTo: floor - height - 10
  });

  addObject({
    solid: true,
    target: true,
    hp: 3,
    graphic: 'pillar',
    aligntl: true,
    pos: [x, y],
    size: [10, height],
    vel: [0, 0],
    fallTo: floor - height,
    onFall: function() { sfx.connect(); },
    onDie: function() { platform.triggered = true; }
  });
}

function dropUpper(x, y) {
  if (won)
    return;
  var increment = 10;
  var heights = [30, 200];
  var width = 20;
  var buryDepth = 10;
  var minPos = 30;

  x -= width/2;

  y = y || -heights[0];
  return prependObject({
    x: x,
    solid: true,
    target: true,
    graphic: 'upper',
    pos: [x, y],
    size: [width, heights[0]],
    vel: [0, 0],
    fallTo: floor - heights[0] + buryDepth,
    onFall: function(o) {
      o.size[1] = heights[1];
      o.state = 'idle';
      o.graphic = 'upper1';
      sfx.connect();
    },
    onAttack: function(o) {
      if (o.state != 'idle')
        return;

      if (o.pos[1] < minPos) {
        o.dead = true;
        sfx.bang();
        return;
      }

      sfx.grow();

      o.state = 'growing';
      var tgt = o.pos[1] - increment;
      o.update = function(o, dt) {
        if (o.pos[1] > tgt)
          o.pos[1] -= 70 * dt;
        else {
          o.state = 'idle';
          delete o.update;
        }
      };
    }
  });
}

function spawnEnemy(spec) {

  var enemy = _.defaults(spec, {
    enemy: true,
    hitSound: 'smallHit',
    dieSound: 'smallHit',
    graphic: 'monster',
    hp: 1,
    hitsSolidObjects: true,
    hitsBounds: true,
    pos: [0, 0],
    size: [10, 10],
    vel: [0, 0],
    dir: -1,
    airborne: true,
    target: true
  });

  addObject(enemy);
  return enemy;
}

function spawnMovingPlatform(spec) {
  var platform = _.defaults(spec, {
    movingPlatform: true,
    hitsSolidObjects: true,
    solid: true,
    enabled: true,
    graphic: 'platform',
    speed: 40,
    pos: [0, 0],
    vel: [0, 0],
    dir: 1,
    size: [30, 10]
  });
  addObject(platform);
  return platform;
}

function spawnEnemySource(spec) {
  var freq = 2 + Math.random() * 2;
  var t = 0;

  if (Math.random() < (1/3))
    t = 2 * freq;

  var x = prependObject(_.defaults(spec, {
    target: true,
    hp: 10,
    graphic: 'pipe',
    size: [16, 16],
    update: function(o, dt) {
      t += dt;
      if (t > freq) {
        t = 0;

        var e = spawnEnemy({pos: o.pos.slice()});
        if (o.etype == 'magic' || Math.random() < (1 / 3)) {
          e.magic = true;
          e.anim = ['gnome1', 'gnome2'];
          e.size = [10, 20];
          delete e.hp;
          e.onAttack = function(e) {
            delete e.anim;
            e.graphic = 'gnome3';
            e.target = false;
            e.enemy = false;
            e.vel = [0, 0];
            e.pos = V.add(e.pos, [0, -2]);
            e.hitObject = false;
            sfx.launch();
            e.update = function(e, dt) {
              e.vel[1] -= 200 * dt;

              if (e.hitObject) {
                e.dead = true;
                explode(e.pos);
              }
            };
          };
        }
      }
    }

  }));
  return x;
}

function smoke(pos) {
  for (var i = 0; i < 3; i++) {
    var v = [Math.random() * 10 - 5, Math.random() * 10 - 5];
    var p = V.add(pos, v);
    console.log(p);
    addObject({
      ttl: Math.random() * 1 + .5,
      //drag: .1,
      graphic: 'smoke',
      pos: p,
      size: [20, 20],
      vel: v
    });
  }
}

function explode(pos) {
  smoke(pos);
  sfx.bang();
}



function spawnNuke(spec) {
  return addObject(_.defaults(spec, {
    hp: 1,
    solid: true,
    target: true,
    graphic: 'target',
    size: [16, 16],
    update: function(o, dt) {
      if (o.hitObject) {
        o.dead = true;
      }
    },
    onDie: function(o) {
      nouncover = true;
      clearBoard();
      setTimeout(twoLevelScenario, 1000);
    }
  }));
}

function spawnBigBlock(spec) {
  return addObject(_.defaults(spec, {
    hp: 2 + Math.floor(Math.random() * 4),
    solid: true,
    target: true,
    graphic: 'bigblock',
    size: [50, 50]
  }));
}


function clearBoard() {
  for (var o of objects) {
    if (!o.player && o.graphic != 'smoke') {
      o.dead = true;
    }
  }
}

function furthest(xs) {
  return _.sortBy(xs, function(x) {
    return -V.magSq(V.sub(player.pos, x));
  })[0];
}


function twoLevelScenario() {

  window.location.hash = '2';

  if (window.doneTls)
    return;
  window.doneTls = true;

  var movers = [];

  sfx.siren();

  var mound = addObject({
    pos: [150, 150],
    graphic: 'mound',
    size: [150, 150],
    solid: true,
    update: function(o, dt) {
      if (o.pos[1] > 75) {
        o.pos[1] -= 23 * dt;
      }
      else {
        delete o.update;
        setTimeout(phase1, 1000);
      }
    }
  });

  function phase1() {

    var wiz = spawnWizard({minTime: 1, pos: furthest([
      [8, 150 - 20],
      [118, 150 - 20]
    ])});

    var q = wiz.onDie;
    wiz.onDie = function(o) {
      q(o);

      setTimeout(function() {
        var woz = spawnWizard({pos: [250, 55]});
        woz.onDie = function() {

          mound.update = function(o, dt) {

            movers = [];
            for (var p of objects) {
              if (p.movingPlatform) {
                if (p.pos[0] < 5) {
                  p.hitsBounds = false;
                  if (p.pos[0] >= 0) {
                    sfx.connect();
                  }
                  p.pos[0] = -10;
                  p.dir = 0;
                  movers.push(p);
                }
              }
            }

            if (movers.length == 3) {
              delete o.update;
              setTimeout(phase2, 1000);
            }

          }
        };
      }, 2000);

    };


    dropCorkscrew(30, 55);
    dropCorkscrew(60, 25);
    dropCorkscrew(90, 70);

    mound.update = function(o, dt) {
      if (player.pos[0] > 200) {
      }
    };
  }

  function getTargetY(i) {
    return Math.floor((i + 1) * 40 + 0);
  }

  function phase2() {
    sfx.move();

    movers = _.sortBy(movers, function(m) { return m.pos[1]; });

    mound.update = function(o, dt) {
      var done = 0;
      movers.forEach(function(mover, i) {
        var targetY = getTargetY(i);

        if (mover.pos[1] > targetY)
          mover.pos[1] -= 20 * dt;

        if (mover.pos[1] < targetY)
          mover.pos[1] += 20 * dt;

        if (Math.abs(mover.pos[1] - targetY) < 5) {
          done += 1;
        }
      });
      if (done == movers.length) {
        delete mound.update;
        setTimeout(phase3, 1000);
      }

    }

  }

  function phase3() {
    delete mound.update;
    mound.pos[1] = 75;

    if (!movers.length) {
      for (var i=0; i<3; i++) {
        spawnMovingPlatform({pos: [-10, getTargetY(i)], dir: 0});
      }
    }

    upperStairsScenario();
    setTimeout(bossScenario, 2000);
  }
}

function bossScenario() {
  var startHp = 5;

  sfx.boss();
  setInterval(function() {
    if (boss && !boss.dead) {
      sfx.boss();
    }
  }, 4000);


  function hitsTaken() { return startHp - boss.hp; }

  var boss = addObject({
    //deadly: true,
    dieSound: 'big-die',
    graphic: 'boss',
    size: [40, 20],
    pos: [140, 20],
    hitsBounds: true,
    target: true,
    hp: startHp,
    onAttack: function() {
      var diff = V.sub(boss.pos, player.pos);
      boss.vel = V.add(boss.vel, V.scale(diff, 80));

    },
    onDie: function() {
      won = true;
      setTimeout(function() {
        clearBoard();
        setTimeout(function() {
          nrandexp(7, function() {
            removeBricksNear([0, 0], 1000);
            setTimeout(function() {
              win();
            }, 1500);
          });
        }, 1500);
      }, 1500);
    }
  });

  function shoot() {
    if (boss && !boss.dead) {

      if (boss.hp > 4) {
        setTimeout(shoot, 2000);
      }
      else if (boss.hp > 1) {
        spawnFireball({pos: boss.pos.slice()});
        setTimeout(shoot, 3000);
      }
      else {
        spawnFireball({pos: boss.pos.slice()});
        setTimeout(shoot, 1200 + 500 * Math.sin(frameNo * 0.005));
      }
    }
  }
  shoot();

  var target = addObject({
    size: [10, 10],
    pos: [30, 20]
  });

  var t = 0;

  boss.vel = [40, 0];

  boss.update = function(o, dt) {
    t += dt;

    var diff = V.sub(target.pos, boss.pos);

    boss.vel = V.add(boss.vel, V.scale(diff, dt));

    var maxSpd = 80;
    var spd = V.mag(boss.vel);
    if (spd > maxSpd)
      boss.vel = V.scale(boss.vel, maxSpd / spd);

    if (hitsTaken() < 2) {
      target.pos[0] = 150 + 100 * Math.sin(t * 0.5);
      target.pos[1] = 20 + 20 * Math.sin(t * 1);
    }
    else if (boss.hp % 2 == 0) {
      target.pos[0] = 75 + 50 * Math.sin(t * 0.5);
      target.pos[1] = 30 + 30 * Math.sin(t * 1);
    }
    else {
      target.pos[0] = 150 + 75 +50 * Math.sin(t * 0.5);
      target.pos[1] = 20 + 20 * Math.sin(t * 1);
    }

    if (boss.pos[1] < 0)
      boss.pos[1] = 0;

  };

}

function spawnWizard(spec) {
  sfx.wizapr();
  var t = 2;
  smoke(spec.pos);
  return addObject(_.defaults(spec, {
    dieSound: 'big-die',
    target: true,
    minTime: .5,
    hp: 2,
    graphic: 'wizard1',
    anim: ['wizard1', 'wizard2'],
    size: [15, 20],
    deadly: true,
    onDie: function(o) {
      smoke(o.pos);
    },
    update: function(o, dt) {
      t -= dt;
      if (t <= 0) {
        t = o.minTime + Math.random() * 2;
        sfx.wizard();
        spawnFireball({pos: o.pos.slice()});
        delete o.anim;
        o.graphic = 'wizard3';
        setTimeout(function() {
          o.graphic = 'wizard1';
          o.anim = ['wizard1', 'wizard2'];
        }, 500);
      }

    }
  }));
}

function spawnFireball(spec) {
  var fb = addObject(_.defaults(spec, {
    size: [6, 6],
    graphic: 'shot1',
    anim: ['shot1', 'shot2'],
    deadly: true,
    target: true,
    ttl: 3,
    projectile: true,
    hp: 1,
  }));

  var diff = V.sub(player.pos, fb.pos);

  fb.vel = V.scale(V.norm(diff), 40);

  fb.update = function(o, dt) {
    if (V.mag(V.sub(o.pos, [0, 0])) > 1000)
      o.dead = true;

    o.vel = V.add(o.vel, V.scale(V.norm(o.vel), dt * 50));
  };

  return fb;
}


function win() {

  prependObject({
    pos: [0, 0],
    size: [300, 150],
    graphic: 'freedom'
  });

  setTimeout(function() {

  prependObject({
    pos: [0, 0],
    size: [300, 150],
    graphic: 'thanks'
  });

  }, 1500);
}
